// Purpose:	ASSERT & TRACE  Ŭ 
// Author : ڱ
// Update : 2003/04/21
// Date	  : 2003/04/18
// Comment:
//      ASSERT, TRACE assert ȿ ˻Ѵ. 
//		ASSERT: Լ  Parameter  ȿ Ǵϰų ݵ Ȯؾ
//          ϴ  ȿ ǴѴ.  Ѿ   ASSERT 
//             ؼ ȵȴ. ASSERT ׸忡 ȿϱ
//          ̴. ׸ ASSERT Ͽ  ۾  
//          ð ʰ α׷   ִ. ̷ ó
//          ó ؾ ϴ 쿡 ASSERT ؼ ȵȴ.
//      TRACE:   Ȯؾ   Ȯ̳   Ȯ 
//          Ѵ. ASSERT  ׸忡 ȿϱ 
//           뿡 ؼ LOG ؾ Ѵ.

#ifndef	__ASSERT_H_
#define	__ASSERT_H_

//
// Definitions
//

// ASSERT TRACE _DEBUG 쿡 ۵Ѵ. 
#if defined(_DEBUG)
	#define	ASSERT(f, sz)								if (!(f)) C_Assert::Assert(__FILE__, __LINE__, sz)
	#define TRACE0(func, ps1)							C_Assert::Trace(__FILE__, __LINE__, func, ps1)
	#define TRACE1(func, sz, ps1)						C_Assert::Trace(__FILE__, __LINE__, func, sz, ps1)
	#define TRACE2(func, sz, ps1, ps2)					C_Assert::Trace(__FILE__, __LINE__, func, sz, ps1, ps2)
	#define TRACE3(func, sz, ps1, ps2, ps3)				C_Assert::Trace(__FILE__, __LINE__, func, sz, ps1, ps2, ps3)
	#define TRACE4(func, sz, ps1, ps2, ps3, ps4)		C_Assert::Trace(__FILE__, __LINE__, func, sz, ps1, ps2, ps3, ps4)
	#define TRACE5(func, sz, ps1, ps2, ps3, ps4, ps5)	C_Assert::Trace(__FILE__, __LINE__, func, sz, ps1, ps2, ps3, ps4, ps5)
#else
	#define	ASSERT(f, sz)
	#define TRACE0
	#define TRACE1
	#define TRACE2
	#define TRACE3
	#define TRACE4
	#define TRACE5
#endif

#if defined(_DEBUG)

///////////////////////
// Includes
///////////////////////

#include <pesc.h>

///////////////////////
// Class
///////////////////////

class C_Assert
{
// Constants, Enumerations & Structures
private:
    static LPCSTR mc_lpszAssertFile;    // Assert  Trace  ϸ

// Constructors & Destructors
public:
	C_Assert();
	~C_Assert();

// Attributes
private:
	static FILE	*ms_pflAssert; // Assert ϴ File handle 
	
// Methods
private:
    static string GetCurrentTm();

public:
	static void Assert(LPCSTR c_lpszFile, int iLine, LPCSTR c_lpszText);
	static void Trace(LPCSTR c_lpszFile, int iLine, LPCSTR c_lpszFunc,
                    LPCSTR c_lpszFormat, ...);
};

#endif  // _DEBUG

#endif  // __ASSERT_H_
